SystemOrganization addCategory: #KanjiBridge!

WARestfulHandler subclass: #KanjiImpex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KanjiBridge'!

!KanjiImpex class methodsFor: 'as yet unclassified' stamp: 'mwa 7/23/2012 21:14'!
initialize
	
	WAAdmin register: self at: 'impex'! !

!KanjiImpex methodsFor: 'as yet unclassified' stamp: 'mwa 7/23/2012 21:21'!
list
	<get>
	
	" call this with curl -i http:/localhost:8080/impex "
	
	^ Kanji tagDict asJson
	

! !

!KanjiImpex methodsFor: 'as yet unclassified' stamp: 'mwa 7/23/2012 22:18'!
load
	<post>
	<consumes: '*/json'>
	
	" 
	 now create a tag dictionary for the kanjis using decoded json 
	curl -H Content-Type: text/json -d @dl.txt http://localhost:8080/impex
	"
	
	| json |
     json := JSJsonParser parse: self requestContext request rawBody.

	json keys do: [ :name |
		(json at: name) do: [ :kId |
			   (Kanji withIndex: kId) tag: name.
			   Transcript show: name, kId asString
			 ] 
		].
	
	Transcript show: json.
	
	 ^'OK'
	
	
! !

Object subclass: #Kanji
	instanceVariableNames: 'glyph keyword meaning index on kun'
	classVariableNames: 'byGlyph byIndex byKeyword tagDict'
	poolDictionaries: ''
	category: 'KanjiBridge'!

!Kanji class methodsFor: 'init' stamp: 'mwa 7/24/2012 17:17'!
addToDicts:  kanji

	byIndex at: kanji index put: kanji.
	byKeyword at: kanji keyword put: kanji.
	byGlyph at: kanji glyph put: kanji
! !

!Kanji class methodsFor: 'access' stamp: 'mwa 7/3/2012 21:55'!
allKeywords
	^ byKeyword keys

	! !

!Kanji class methodsFor: 'setup' stamp: 'mwa 7/30/2012 21:30'!
build
	
	| kw mn k kun |
	

	kw :=  Kanji grabfile: 'keywords'.
	kw do: [ :line |
		Kanji newWithGlyph: (line at: 1) andKeyword: (line at: 2) andIndex: (line at:  4)
	].
	mn := Kanji grabfile: 'meanings'.
	mn do: [ :line |
		k := Kanji withIndex: (line at: 3).
		((line size) < 5)  ifTrue: [ kun := '' ] ifFalse: [kun := (line at: 5)].   
		k setMeaning: (line at: 2) andOn: (line at: 4) andKun: kun  	
	]! !

!Kanji class methodsFor: 'init' stamp: 'mwa 7/24/2012 15:52'!
containsString:   str

	  
	 | filtered |
	filtered := Kanji allKeywords 
		select: [ :each | each includesSubstring: str caseSensitive: false ].
	filtered size > 10
		ifTrue: [ filtered := filtered first: 10 ].
	^ filtered 
	
! !

!Kanji class methodsFor: 'setup' stamp: 'mwa 7/31/2012 20:41'!
grabfile:  fname
" grab a file and return a list of lists"

| text lines entries home | 


(FileDirectory  default directoryExists:  '/Users') ifTrue: [
  		home := '/Users'	
	]  ifFalse: [
 		home := '/home'	
	].


	
text  := (FileStream oldFileNamed: home, '/mark/kanjibridge/', fname, '.txt') upToEnd. 

lines := text findTokens:  (Character lf) .

entries  := OrderedCollection  new.

lines do: [ :line | 
	| items |
	items := line findTokens:   (Character tab).
	(items size) > 1 ifTrue:
	 [ entries add: items].
	].
 ^ entries.! !

!Kanji class methodsFor: 'init' stamp: 'mwa 7/24/2012 17:17'!
initialize

	byKeyword := Dictionary new.
	byIndex := Dictionary new.
	byGlyph := Dictionary new.
	tagDict := Tag new.
	tagDict initialize.
	Kanji build.	! !

!Kanji class methodsFor: 'init' stamp: 'mwa 6/27/2012 13:59'!
newWithGlyph: aGlyph andKeyword: aKeyword andIndex: anIndex
	"comment stating purpose of message"

	| newObj  |
	
	newObj := Kanji new.
	newObj glyph: aGlyph.
	newObj keyword: aKeyword.
	newObj index: anIndex.
	Kanji addToDicts: newObj.
	
	^ newObj! !

!Kanji class methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:51'!
tagDict
	^ tagDict! !

!Kanji class methodsFor: 'lookup' stamp: 'mwa 7/24/2012 17:18'!
withGlyph: glyph 
	
	^ byGlyph at: glyph! !

!Kanji class methodsFor: 'lookup' stamp: 'mwa 6/27/2012 13:57'!
withIndex: index 
	
	^ byIndex at: (index asString)! !

!Kanji class methodsFor: 'lookup' stamp: 'mwa 6/27/2012 12:45'!
withKeyword: keyword
	
	^ byKeyword at: keyword! !

!Kanji class methodsFor: 'as yet unclassified' stamp: 'mwa 7/17/2012 20:28'!
withTag:  tagName

	^ (Kanji tagDict) objectsWithTag: tagName! !

!Kanji methodsFor: 'as yet unclassified' stamp: 'mwa 6/29/2012 15:59'!
asString
	 ^ '[Kanji ' , index , ']'! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/27/2012 21:21'!
glyph

	^ glyph 
! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/26/2012 21:40'!
glyph: aGlyph
	"comment stating purpose of message"

	glyph := aGlyph
! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/27/2012 12:49'!
index
	  ^ index 
	
	! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/27/2012 12:36'!
index: anIndex
	index := anIndex.
	
	! !

!Kanji methodsFor: 'access' stamp: 'mwa 7/23/2012 21:02'!
jsonOn: aStream

	aStream nextPutAll: index
! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/27/2012 09:23'!
keyword
	 ^ keyword ! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/26/2012 21:41'!
keyword: aKeyword
	"comment stating purpose of message"

	keyword := aKeyword! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/27/2012 21:42'!
kun
	^ kun
! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/27/2012 21:42'!
meaning

	^meaning
! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/27/2012 21:41'!
on

	^on
! !

!Kanji methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 21:25'!
printOn: aStream

	aStream nextPutAll: '<kanji ', index, ':', keyword, '>'! !

!Kanji methodsFor: 'access' stamp: 'mwa 6/27/2012 13:41'!
setMeaning: aMeaning andOn: anOn andKun: aKun 	

	meaning := aMeaning.
	on := anOn.
	kun := aKun.! !

!Kanji methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:23'!
tag: name

	tagDict named: name onObject: self! !

!Kanji methodsFor: 'as yet unclassified' stamp: 'mwa 7/17/2012 20:21'!
tags

	^tagDict tagsForObject: self! !

Object subclass: #Tag
	instanceVariableNames: 'objectsWithTag tagsForObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KanjiBridge'!

Tag class
	instanceVariableNames: 'ObjectsWithTag TagsForObject'!

Tag class
	instanceVariableNames: 'ObjectsWithTag TagsForObject'!

!Tag methodsFor: 'as yet unclassified' stamp: 'mwa 7/23/2012 20:59'!
asJson
	
	^objectsWithTag asJson! !

!Tag methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:07'!
initialize
	objectsWithTag ifNil: [objectsWithTag := Dictionary new].
	tagsForObject ifNil: [tagsForObject := Dictionary new].
	! !

!Tag methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:08'!
named: aName onObject: anObject
	
	(objectsWithTag includesKey: aName) ifFalse:  [ objectsWithTag at: aName put: Set new].
	(objectsWithTag at: aName) add: anObject.
	
	(tagsForObject includesKey: anObject) ifFalse:  [ tagsForObject at: anObject put: Set new].
	(tagsForObject at: anObject) add: aName.
	! !

!Tag methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:09'!
objectsWithTag: aName
	(objectsWithTag includesKey: aName) ifFalse: [ ^ Set new ].
	^ objectsWithTag at: aName! !

!Tag methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:09'!
reset
	objectsWithTag := Dictionary new.
	tagsForObject := Dictionary new.
	! !

!Tag methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:08'!
tagsForObject: anObject
	(tagsForObject  includesKey: anObject) ifFalse: [ ^ Set new ].
	^ tagsForObject at: anObject
! !

Object subclass: #Viz
	instanceVariableNames: 'l'
	classVariableNames: 'g'
	poolDictionaries: ''
	category: 'KanjiBridge'!

!Viz class methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:29'!
classm
	g := 1! !

!Viz methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:31'!
instm
	l := 2.
	g := 3! !

!Viz methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 20:32'!
instm2
	l := g! !

Object subclass: #Word
	instanceVariableNames: 'kanji kana meaning'
	classVariableNames: 'allWords kanjiDict tagDict'
	poolDictionaries: ''
	category: 'KanjiBridge'!

!Word class methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 21:05'!
initialize 
	allWords := Dictionary new.
	kanjiDict := Dictionary new.
	tagDict := Tag new.
	tagDict initialize.! !

!Word class methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 19:55'!
wordsForKanji: kanji
	^#( new Word )! !

!Word methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 21:14'!
addToKanjiDict

	kanji do: [ :k | 
		(kanjiDict includesKey: k) ifFalse:  [ kanjiDict at: k put: Set new].
		(kanjiDict at: k) add: self
	]! !

!Word methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 21:23'!
printOn: aStream

	aStream nextPutAll: '<word ', kanji, '>'! !

!Word methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 19:53'!
renderOn: html
	html text: 'text of word'! !

!Word methodsFor: 'as yet unclassified' stamp: 'mwa 7/2/2012 21:16'!
withKanji: aKanji andKana: aKana andMeaning: aMeaning
	kanji := aKanji.
	kana := aKana.
	meaning := aMeaning.
	self addToKanjiDict.
	^ self
	! !

WAComponent subclass: #KanjiView
	instanceVariableNames: 'kanji flipped'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KanjiBridge'!

!KanjiView class methodsFor: 'as yet unclassified' stamp: 'mwa 7/24/2012 13:27'!
initialize 

  | application |
	application := WAAdmin register: self asApplicationAt: 'kanji'.
	
	application preferenceAt: #scriptGeneratorClass put: JQScriptGenerator.
	
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary! !

!KanjiView methodsFor: 'display' stamp: 'mwa 7/2/2012 20:53'!
addTag
	| name |
	name := self request: 'Tag name'.
	(self kanji) tag: name
	"Tag named: name onObject: (self kanji)."
	
	! !

!KanjiView methodsFor: 'orientation' stamp: 'mwa 6/27/2012 22:16'!
back
	flipped := true! !

!KanjiView methodsFor: 'orientation' stamp: 'mwa 6/27/2012 22:03'!
flip
	flipped := (self flipped) not! !

!KanjiView methodsFor: 'orientation' stamp: 'mwa 6/27/2012 22:07'!
flipped 
	flipped ifNil: [ flipped := false]. 
	 ^ flipped! !

!KanjiView methodsFor: 'orientation' stamp: 'mwa 6/27/2012 22:14'!
front
	flipped := false! !

!KanjiView methodsFor: 'access' stamp: 'mwa 6/27/2012 21:03'!
kanji
	^ kanji  ifNil: [ kanji := Kanji withIndex: 1]! !

!KanjiView methodsFor: 'access' stamp: 'mwa 6/27/2012 21:04'!
kanji: aKanji
	kanji := aKanji
	! !

!KanjiView methodsFor: 'setup' stamp: 'mwa 6/27/2012 21:37'!
nextKanji

	kanji := Kanji withIndex: (((self kanji) index) + 1)
	
	
! !

!KanjiView methodsFor: 'orientation' stamp: 'mwa 6/27/2012 22:18'!
onBack 
	flipped ifNil: [ flipped := false]. 
	 ^ flipped! !

!KanjiView methodsFor: 'display' stamp: 'mwa 7/24/2012 19:16'!
renderContentOn: html


      html form: [
	html text: 'Go Keywd'.
	html textInput
		id: html lastId;
		size: 15;
		script: (html jQuery this autocomplete
			sourceCallback: [ :term | Kanji containsString: term]);
		callback: [ :value | kanji := Kanji withKeyword: value].
	].

      html form: [
	html text: 'Go Index'.
	html textInput
		size: 4;
		callback: [ : value | kanji := Kanji withIndex: value].
	].		
	html form: [
	html text: 'Go Kanji'.
	html textInput
		size: 2;
		callback: [ : value | kanji := Kanji withGlyph: value].
	].
	
	html break.
      html text: (self kanji keyword) , ':',  (self kanji index).
	html div
		class: 'kanji';
		with: self kanji glyph.

	html break.
	
	html anchor 
		callback: [self front. self  nextKanji];
		with:  'Next Kanji'.
	html break.
	
	self onBack ifFalse: [
		html anchor
			callback: [self back];
			with: 'show'
	] ifTrue: [

		html text: self kanji meaning
	].
"
	html heading: 'words'.
	html break.
	html unorderedList: [
	(Word wordsForKanji:  (self kanji)) do: [ :word |
		word renderOn: html]
	].
"
	html heading: 'tags'.
	html break.
	
	((Kanji tagDict) tagsForObject:  (self kanji)) do: [ :name |
		html text: name.
		((Kanji tagDict) objectsWithTag: name) do: [ :alsoTagged |
			html anchor callback: [ kanji := alsoTagged ]; 
				with: (alsoTagged glyph) 
			].
		html break.
	].
	
	html break.
	html anchor 
		callback: [ self addTag  ];
		with: 'add'.
		! !

!KanjiView methodsFor: 'as yet unclassified' stamp: 'mwa 7/24/2012 19:15'!
style

	 ^ '
	.normal { font-size: 50 pt; }
	.kanji { font-size: 40pt; }
	'! !

WAComponent subclass: #UploadForm
	instanceVariableNames: 'lines count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KanjiBridge'!

!UploadForm methodsFor: 'as yet unclassified' stamp: 'mwa 7/3/2012 21:39'!
receiveFile: aFile
	
	count := 0.
	self halt.
	
      lines := (Character lf) split: (aFile rawContents).

	lines do: [:line
		| count := count + 1.		
	]! !

!UploadForm methodsFor: 'as yet unclassified' stamp: 'mwa 7/3/2012 21:23'!
renderContentOn: html

	html form multipart; with: [
			html fileUpload
				callback: [ :value | self receiveFile: value].
			html submitButton: 'Send File']! !
KanjiImpex initialize!
Kanji initialize!
Word initialize!
KanjiView initialize!
